<template>
  <div>
    <div class="container mx-auto rounded-lg">
      <div>
        <div class="font-bold text-sm text-blue-500 px-4 mt-6 mb-2">
          Account
        </div>
        <div class="flex flex-row justify-end bg-white shadow-md md:shadow-none">
          <div
            @click="logoutClick()"
            class="clickable border border-red-500 bg-red-100 px-4 py-2 rounded m-4 font-bold text-red-500"
          >
            Logout
          </div>
        </div>
      </div>
    </div>
    <div class="container mx-auto rounded-lg">
      <div>
        <div class="font-bold text-sm text-blue-500 px-4 mt-8 mb-2">
          General
        </div>
        <div
          @click="Push.isAvailable() ? toggleNotifications() : null"
          class="px-4 py-4 bg-white shadow-md md:shadow-none flex flex-row items-center justify-between clickable-bg"
        >
          <div>
            Notifications
            <div class="text-sm text-gray-500 font-light">
              <span v-if="Push.isDenied()">You denied Notifications in your browser</span>
              <span v-else-if="!Push.isSupported()">Push is not supported on this device</span>
              <span v-else-if="Push.isEnabled()">Push is enabled on this device</span>
              <span v-else>Push is not enabled on this device</span>
            </div>
          </div>
          <switch-box :disabled="!Push.isAvailable()" :value="Push.isEnabled()" :loading="pushLoader.loading" />
        </div>
      </div>
    </div>
    <div class="container mx-auto rounded-lg">
      <div>
        <div class="font-bold text-sm text-blue-500 px-4 mt-8 mb-2">
          About
        </div>
        <div class="px-4 py-4 bg-white shadow-md md:shadow-none">
          Version
          <div class="text-sm text-gray-500 font-light">You are using version {{ version }}</div>
        </div>
        <a
          href="https://owner.todoninja.de"
          target="_blank"
          class="px-4 py-4 block clickable-bg flex flex-row items-center justify-between  bg-white shadow-md md:shadow-none"
        >
          <div>
            Sebastian Dittrich
            <div class="text-sm text-gray-500 font-light">Developer of this application</div>
          </div>
          <i class="hero external-link outline text-gray-500"></i>
        </a>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import localforage from "localforage";
import { Auth } from "@/assets/Auth";
import SwitchBox from "./SwitchBox.vue";
import { Push } from "@/assets/Push";
import { Loader } from "@/use/Loader";

export default {
  components: { SwitchBox },
  setup() {
    const pushLoader = new Loader();
    return {
      logoutClick: async () => {
        await Auth.logout();
        await localforage.clear();
        window.location.reload();
      },
      pushLoader,
      toggleNotifications: () =>
        pushLoader.load(async () => {
          await Push.initing;
          if (!Push.isEnabled()) {
            await Push.enable();
          } else {
            await Push.disable();
          }
        }),
      Push,
      version: JSON.parse(unescape(process.env.PACKAGE_JSON || '{"version":"unknown"}')).version
    };
  }
};
</script>
